using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Media;
using Avalonia.Media.Imaging;
using System;
using System.Data;
using System.Diagnostics;
using System.Runtime.Intrinsics.Arm;
using Avalonia.Threading;
using System.Runtime.InteropServices;
using System.Threading.Tasks;
using Tmds.DBus.Protocol;
using System.IO;
using System.Linq;
using static System.Runtime.InteropServices.JavaScript.JSType;
using Avalonia.Input;
using System.Reflection.Metadata.Ecma335;
using System.Text.RegularExpressions;
using System.Text;

namespace AvaloniaApplication1
{
    public struct DateB
    {
        public string dayB;
        public string mounthB;
        public string yearB;
    }
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();


        }

        public void Button_Click(object source, RoutedEventArgs args)
        {
            string date = dateT.SelectedDate.ToString();

            if (date == "")
            {
                Error.Text = "   ";
            }
            else
            {
                int day = int.Parse(date.Substring(0, 2));
                int mounth = int.Parse(date.Substring(3, 2));
                int year = int.Parse(date.Substring(6, 4));

                DateTime BD = new DateTime(year, mounth, day);
                DateTime ToDay = DateTime.Now;


                if (BD > ToDay)
                {
                    Error.Text = "   ";
                }
                else
                {
                    Error.Text = "";
                    int Vis = 0;
                    int DbWeek = 0;
                    DateTime dayW;
                    int age = ToDay.Year - BD.Year;
                    int months = ToDay.Month - BD.Month;
                    int days = ToDay.Day - BD.Day;

                    if (ToDay.Month < BD.Month || (ToDay.Month == BD.Month && ToDay.Day < BD.Day))
                    {
                        age--;
                    }

                    if (days < 0)
                    {
                        months--;
                        days += DateTime.DaysInMonth(ToDay.Year, ToDay.Month - 1);
                    }

                    if (months < 0)
                    {
                        months += 12;
                    }
                    VisY.Text = " : ";
                    string DayOfWeek = BD.DayOfWeek.ToString();
                    for (int i = year; i <= ToDay.Year; i++)
                    {
                        if (i % 4 == 0)
                        {

                            VisY.Text = VisY.Text + i + " ";
                            Vis++;
                        }
                        dayW = new DateTime(i, mounth, day);

                        if (dayW.DayOfWeek.ToString() == DayOfWeek && dayW != BD && dayW != ToDay)
                        {
                            DbWeek++;
                        }
                    }

                    if (DayOfWeek == "Monday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Tuesday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Wednesday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Thursday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Friday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Saturday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Sunday")
                    {
                        DayOfWeek = "";
                    }

                    dayOfWeek.Text = " : " + DayOfWeek;
                    yearT.Text = " : " + age.ToString();
                    mounthT.Text = " : " + months.ToString();
                    daysT.Text = " : " + days.ToString();
                    DBW.Text = "     " + DayOfWeek + ": " + DbWeek;
                    Viss.Text = "  : " + Vis;
                }
                if (Zod.IsChecked == false && Vost.IsChecked == false)
                {

                }
                if (Vost.IsChecked == true)
                {
                    Znak.Text = "  : " + Vostoch(year);
                }
                if (Zod.IsChecked == true)
                {
                    Znak.Text = " : " + Zodiac(day, mounth);
                }

            }

        }
        public string Vostoch(int year)
        {
            string[] ZnakV = new string[]
            {
                        "", "", "", "", "",
                        "", "", "", "", "",
                        "", ""
            };
            int index = (year - 4) % 12;
            return ZnakV[index];
        }
        public string Zodiac(int day, int mounth)
        {
            string Zod = " ";
            if (day >= 21 && mounth == 3 || day <= 19 && mounth == 4)
            {
                Zod = "";

            }
            else if (day >= 20 && mounth == 4 || day <= 20 && mounth == 5)
            {
                Zod = "";
            }
            else if (day >= 21 && mounth == 5 || day <= 20 && mounth == 6)
            {
                Zod = "";
            }
            else if (day >= 21 && mounth == 6 || day <= 22 && mounth == 7)
            {
                Zod = "";
            }
            else if (day >= 23 && mounth == 7 || day <= 22 && mounth == 8)
            {
                Zod = "";
            }
            else if (day >= 23 && mounth == 8 || day <= 22 && mounth == 9)
            {
                Zod = "";
            }
            else if (day >= 23 && mounth == 9 || day <= 22 && mounth == 10)
            {
                Zod = "";
            }
            else if (day >= 23 && mounth == 10 || day <= 21 && mounth == 11)
            {
                Zod = "";
            }
            else if (day >= 22 && day <= 31 && mounth == 11 || day <= 21 && mounth == 12)
            {
                Zod = "";
            }
            else if (day >= 22 && mounth == 12 || day <= 19 && mounth == 1)
            {
                Zod = "";
            }
            else if (day >= 20 && mounth == 1 || day <= 18 && mounth == 2)
            {
                Zod = "";
            }
            else if (day >= 19 && mounth == 2 || day <= 20 && mounth == 3)
            {
                Zod = "";
            }
            else
            {
                Zod = "    ";
            }
            return Zod;
        }

        [Obsolete]
        public async void Filee(object source, RoutedEventArgs args)
        {
            string header = "";
            string path;
            int k = 0;
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.AllowMultiple = false;
            OFD.Filters.Add(new FileDialogFilter() { Name = "CSV ", Extensions = { "csv" } });
            var result = await OFD.ShowAsync(this);
            if (result != null)
            {
                Error.Text = " ";
                path = result[0];
                string[] lines = File.ReadAllLines(path);
                if (lines.Length > 0)
                {
                    DateB[] dateB = new DateB[lines.Length - 1];
                    Encoding.RegisterProvider(CodePagesEncodingProvider.Instance);
                    using (StreamReader sr = new StreamReader(path, Encoding.GetEncoding(1251)))
                    {
                        string line = sr.ReadLine();
                        header = line;
                        line = sr.ReadLine();
                        while (line != null)
                        {
                            string[] strs = line.Split(";").ToArray();
                            dateB[k].dayB = strs[0];
                            dateB[k].mounthB = strs[1];
                            dateB[k].yearB = strs[2];
                            k++;
                            line = sr.ReadLine();
                        }
                    };
                    int s = 0;
                    using (StreamWriter sw = new StreamWriter("Output.csv", false, Encoding.GetEncoding(1251)))
                    {                  
                        sw.WriteLine(header + ";" + " " + ";" + " ");
                        for (int i = 0; i<k; i++)
                        {
                            bool isNumericMounthNotInt = Regex.IsMatch(dateB[i].mounthB, @"^(\d+|0),\d+$");
                            bool isNumericDayDate = Regex.IsMatch(dateB[i].dayB, @"^\d{2}\.\d{2}\.\d{4}$");
                            bool isNumericDayOtr = Regex.IsMatch(dateB[i].dayB, @"^-?\d+$");
                            bool isNumericMounthOtr = Regex.IsMatch(dateB[i].mounthB, @"^-?\d+$");
                            bool isNumericYearOtr = Regex.IsMatch(dateB[i].yearB, @"^-?\d+$");
                            bool isNumericDay = Regex.IsMatch(dateB[i].dayB, @"^\d+$");
                            bool isNumericMounth = Regex.IsMatch(dateB[i].mounthB, @"^\d+$");
                            bool isNumericYear = Regex.IsMatch(dateB[i].yearB, @"^\d+$");
                            if (isNumericDay == true & isNumericMounth == true && isNumericYear == true)
                            {
                                sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + Zodiac(int.Parse(dateB[i].dayB), int.Parse(dateB[i].mounthB)) + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                            }
                            else if (isNumericDay == true & isNumericMounth == false && isNumericYear == true)
                            {
                                if(dateB[i].mounthB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }                      
                                else if(isNumericMounthOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if(dateB[i].mounthB != " ")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                            }
                            else if (isNumericDay == false & isNumericMounth == true && isNumericYear == true)
                            {
                                if (dateB[i].dayB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (isNumericDayOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (dateB[i].dayB != " ")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                            }
                            else if (isNumericDay == true & isNumericMounth == true && isNumericYear == false)
                            {
                                if (dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + Zodiac(int.Parse(dateB[i].dayB), int.Parse(dateB[i].mounthB)) + ";" + "  ");
                                }
                                else if (isNumericYearOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + Zodiac(int.Parse(dateB[i].dayB), int.Parse(dateB[i].mounthB)) + ";" + "   ");
                                }
                                else if (dateB[i].yearB != " ")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + Zodiac(int.Parse(dateB[i].dayB), int.Parse(dateB[i].mounthB)) + ";" + "   ");
                                }
                            }
                            else if (isNumericDay == false && isNumericMounth == false && isNumericYear == false)
                            {
                                if (dateB[i].dayB == "" && dateB[i].mounthB == "" && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    " + ";" + "  ");
                                }
                                else if (dateB[i].dayB == "" && dateB[i].mounthB == "" && isNumericYearOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    " + ";" + "   ");
                                }
                                else if (dateB[i].dayB == "" && isNumericMounthOtr == true && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  .    " + ";" + "  ");
                                }
                                else if (isNumericDayOtr == true && dateB[i].mounthB == "" && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   .   " + ";" + "  ");
                                }
                                else if (isNumericDayDate == true && dateB[i].mounthB == "" && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    .   " + ";" + "  ");
                                }
                                else if (dateB[i].dayB == "" && dateB[i].mounthB == "" && dateB[i].yearB != "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    " + ";" + "   ");
                                }
                            }
                            else if (isNumericDay == false & isNumericMounth == false && isNumericYear == true)
                            {
                                if (dateB[i].dayB == "" && dateB[i].mounthB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (isNumericDayOtr == true && dateB[i].mounthB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   .   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (dateB[i].dayB == "" && isNumericMounthOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  .    " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (dateB[i].dayB != "" && dateB[i].mounthB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   .   " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (dateB[i].dayB == "" && dateB[i].mounthB != "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  .    " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                                else if (isNumericDayOtr == true && isNumericMounthOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "     " + ";" + Vostoch(int.Parse(dateB[i].yearB)));
                                }
                            }
                            else if (isNumericDay == true & isNumericMounth == false && isNumericYear == false)
                            {
                                if (dateB[i].mounthB == "" && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "  " + ";" + "  ");
                                }
                                else if (isNumericMounthOtr == true && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + "  ");
                                }
                                else if(isNumericMounthNotInt == true && dateB[i].yearB == "")
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "    " + ";" + "  ");
                                }
                                else if (dateB[i].mounthB != "" && isNumericYearOtr == true)
                                {
                                    sw.WriteLine(dateB[i].dayB + ";" + dateB[i].mounthB + ";" + dateB[i].yearB + ";" + "   " + ";" + "   ");
                                }

                            }
                        }
                    };
                    Process.Start(new ProcessStartInfo
                    {
                        FileName = "Output.csv",
                        UseShellExecute = true
                    });
                }
                else
                {
                    Error.Text = "  ";
                }
            }
        }
    }
}